; Just a little assembler oscilloscope program.  Nothing amazing really...
; Tries to get standard BIOS 'hi-res' mode so should work in all display
; modes.  Not amazingly fast since it uses standard BIOS calls to do the
; plotting, but there we go....

start:
call clear_screen
call delay1
mov cx,0
mov bh,0

get_sample:
mov dx,300h
in al,dx      ; now get ADC data and store in al

mov dl,al     ; plotting code >>
mov dh,0
mov al,1
mov ah,0Ch
int 10h       ; plot the data point
inc cx        ; increment x position
call  delay1

cmp cx,280h   ; end of line ?
jz key_press  ; yes

mov dx, 301h  ; no, so start another conversion
out dx,al
jmp get_sample

key_press:
mov ah,0Bh    ; key pressed ?
int 21h
cmp al,0FF
jnz start     ; no, so display another screen..

mov ah,0      ; yes, so reset screen
mov al,03h
int 10h
mov ah,4Ch    ; and return to DOS
int 21h

delay1:
mov bl,19h
loop1:
dec bl
cmp bl,00
jnz loop1
ret

clear_screen:
mov ah,0
mov al,11h
int 10h
ret

clear_line:
mov dl,0ff
loop2:
mov dh,0
mov al,0
mov ah,0c
int 10h
dec dl
cmp dl,00
jnz loop2
ret
