/***************************************************************/
/*                   SOUND.C                                   */
/***************************************************************/
/*    Written : 29-04-1992                                     */
/*         By : Neil Johnson                                   */
/*        For : IBM PC & Compatibles                           */
/*   Language : Microsoft C ( written in QuickC 2.5 )          */
/*    Version : 1.0                                            */
/***************************************************************/
/*                 Notes :-                                    */
/*  1) Compile using atleast the COMPACT memory model.         */
/***************************************************************/

#include <malloc.h>
#include <graph.h>
#include <io.h>
#include <conio.h>
#include <stdio.h>
#include <fcntl.h>          /* O_ constant definitions */
#include <process.h>
#include <stdlib.h>

#define BASE_PORT 0x300
#define OR ||

#include "intrcrd1.c"

/*********************************************************************/

main()
   {

   /* declare variables */

   char string[30], *sample_ptr, loop_flag=1, sample_flag=0, save_flag=0;
   unsigned int sample_size, del, result;
   int filehandle;

   /* main program code */
   clrscr();
   while(loop_flag)
   {
      menu_screen();
      switch(get_menu_selection())
      {
	 case 1:
	    {
	    dialogue("Enter No. Of Samples (max 65000):");
	    gets(string);
	    sample_size=atoi(string);
	    dialogue("Enter delay (0 to 255):");
	    gets(string);
	    del=atoi(string);
	    if (del>255)
	       {
	       dialogue("\aError >> delay too long");
	       break;
	       }

    /* now allocate enough memory for the sample */

	    if ( (sample_ptr=(unsigned char*) malloc((size_t)sample_size))==NULL)
	    {
	    dialogue("\aError >> not enough memory.");
	    break;
	    }

    /* o.k. got block of memory, now get ready to take sample... */
	    dialogue("Press RETURN key to start recording...");
	    gets(string);

    /* o.k. now record the sample*/

	    dialogue("<< R E C O R D I N G >>\a");
	    if ((result=_GetSample ( sample_ptr, sample_size, (unsigned char)del))==-1)
	       {
	       dialogue("\aError >> can't record sample.");
	       break;
	       }
	    dialogue("\a<< F I N I S H E D >>");
	    sample_flag=1;
	    save_flag=0;
	    break;
	    }

	 case 2:
	    {
	    if(sample_flag)
	       {
	       dialogue("Playback speed ( 0 to 255 ):");
	       gets(string);
	       del=atoi(string);
	       if (del>255)
		  {
		  dialogue("\aError >> speed out of range");
		  break;
		  }

   /* now play the sound through the DAC board */

	       if ( _PlaySample( sample_ptr,(unsigned int)sample_size,(char)del ) == -1 )
		  {
		  dialogue("\aError >> can't play sample.");
		  break;
		  }
	       }
	       else
	       {
	       dialogue("Error >> There's no sample to play !\a");
	       for(del=0;del<100;del++)
		  {  /* small delay loop */
		  }
	       }
	    break;
	    }

	 case 3:
	    {
   /* now play the sound through the DAC board */
	    int hiccup, key;     /* hiccup is the delay value */
	    unsigned int loop;
	    char *play, fin;   /* pointer to data buffer    */

	    if(sample_flag)
	       {
	       dialogue(" Keyboard layout :     2 3   5 6 7\n        x - quit         q w e r t y u i");
	       do
		  {
		  key=getch();
		  switch (key)
		     {
		     case 'q': hiccup=49;  break;
		     case '2': hiccup=44;  break;
		     case 'w': hiccup=40;  break;
		     case '3': hiccup=36;  break;
		     case 'e': hiccup=33;  break;
		     case 'r': hiccup=30;  break;
		     case '5': hiccup=28;  break;
		     case 't': hiccup=25;  break;
		     case '6': hiccup=23;  break;
		     case 'y': hiccup=20;  break;
		     case '7': hiccup=17;  break;
		     case 'u': hiccup=14;  break;
		     case 'i': hiccup=12;  break;
		     }
		  if ((key=='q') OR (key=='2') OR (key=='w') OR (key=='3') OR
		      (key=='e') OR (key=='r') OR (key=='5') OR (key=='t') OR
		      (key=='6') OR (key=='y') OR (key=='7') OR (key=='u') OR
		      (key=='i') OR (key=='x'))
		     {
		     play=sample_ptr;
		     if (key!='x')
			{
			fin=1;
			loop=0;
			do
			   {
			   outp(BASE_PORT,(int)*play + 0);
			   pause (hiccup);
			   play++;
			   loop++;
			   if (!(loop%200))
			      {
			      fin=!kbhit();
			      }
			   }
			while((loop<sample_size) && fin);
			}
		     }
		  }
	       while (key!='x');
	       }
	    break;
	    }

	 case 4:
	    {
	    if (sample_flag)
	       {
	       dialogue("Enter name of file :");
	       gets(string);

	       if( ( filehandle=open( string,O_CREAT | O_WRONLY) ) == -1L)
		  {
		  dialogue("Error >> cannot create file.\a");
		  break;
		  }

	       if( write( filehandle,sample_ptr,(unsigned)sample_size ) == -1 )
		  {
		  dialogue("Error >> cannot write to file.\a" );
		  break;
		  }

	       close(filehandle);
	       save_flag=1;
	       }
	       else
	       {
	       dialogue("Error >> no sample to save !\a");
	       for(del=0;del<100;del++);
		  {
		  }        /* small delay loop */
	       }
	    break;
	    }

	 case 5:
	    {
	    unsigned int length;
	    char *buf;

	    if (sample_flag)
	       {
	       char answer;
	       dialogue("\aWarning ! This will erase the sample currently in memory.  Continue (y/n) ?");
	       answer=getch();
	       if (answer=='n' || answer=='N')  /* No ! */
		  {
		  break;
		  }
	       }

	    dialogue("Enter name of file :");
	    gets(string);

   /* can we open the named sound file ?  */

	    if( ( filehandle=open( string,O_BINARY | O_RDONLY) ) == -1L)
	       {
	       dialogue("Error >> cannot open file.");
	       break;
	       }

   /* will this file fit inside 64k ? */

	    if ((length=filelength(filehandle))>65535)
	       {
	       dialogue("Error >> file is too big.");
	       break;
	       }

   /* yes it is, but is there enough memory available to hold it ? */

	    if( (buf=(char *)malloc((size_t)length))==NULL)
	       {
	       printf("Error >> not enough memory to store file");
	       break;
	       }

   /* ok, so read in blocks of data if possible */

	    if( read( filehandle,buf,(unsigned)length ) == -1 )
	       {
	       dialogue("Error >> cannot read file." );
	       break;
	       }
	    sample_size=length;
	    sample_ptr=buf;
	    close(filehandle);
	    sample_flag=1;
	    save_flag=1;
	    break;
	    }

	 case 6:
	    {
	    if(sample_flag && !save_flag)
	       {
	       char answer;
	       dialogue("\aWarning ! Sample not saved.  Continue (y/n) ?");
	       answer=getch();
	       if (answer=='n' || answer=='N')  /* No ! */
		  {
		  break;
		  }
	       }
	    loop_flag=0;
	    break;
	    }

	 default:
	    {
	    beep();
	    }
	 }
      }
   if (sample_flag)
      {
      free( sample_ptr );
      }
   clrscr();
   }

/*********************************************************************/
/*              FUNCTIONS                                            */
/*********************************************************************/

clrscr()
   {
   _clearscreen(_GCLEARSCREEN );
   }


menu_screen()
   {
   _settextposition(0,0);
   printf("ͻ\n");
   printf("          S O U N D   R E C O R D E R        Version 1.0                    \n");
   printf("͹\n");
   printf("             SOUND                                    FILE                 \n");
   printf("Ķ\n");
   printf("                                                                           \n");
   printf("          1>  Record                               4>  Save                \n");
   printf("                                                                           \n");
   printf("          2>  Playback                             5>  Load                \n");
   printf("                                                                           \n");
   printf("          3>  Keyboard                             6>  Quit                \n");
   printf("                                                                           \n");
   printf("ͼ\n");
   printf("                                                                              \n");
   printf("                                                                              \n");
   printf("                                                                              \n");
   printf("                           ͻ                             \n");
   printf("                            SELECT MENU OPTION                              \n");
   printf("                           ͼ                             \n");
   printf("                                                                              \n");
   }


get_menu_selection()
   {
   char answer;

   answer=getch();
   return(atoi(&answer));
   }

beep()
   {
   printf("\a");
   }

dialogue(message)
char *message;
   {
   _settextposition(15,0);
   printf("Ŀ\n");
   printf("                                                                            \n");
   printf("                                                                            \n");
   printf("                                                                            \n");
   printf("\n");
   _settextposition(17,5);
   printf(message);
   }

pause ( delay )
int delay;
   {
   int loop;
   for (loop=0;loop<delay;loop++);
   }

