/***************************************************************
 *                   SOUND.C                                   *
 *  Second version of sound sampler/player program for the     *
 *  InterCard 1 interface card for the PC.                     *
 ***************************************************************
 *    Written : 1st October 1993                               *
 *         By : Neil Johnson                                   *
 *        For : IBM PC & Compatibles                           *
 *   Language : Microsoft C ( written in QuickC 2.5 )          *
 *    Version : 2.0                                            *
 ***************************************************************
 *                 Notes :-                                    *
 *  Requires the TextWin library to be LINK'ed with this code  *
 *  Compile using the LARGE memory model                       *
 ***************************************************************/


#include <malloc.h>
#include <graph.h>
#include <io.h>
#include <conio.h>
#include <stdio.h>
#include <fcntl.h>          /* O_ constant definitions */
#include <process.h>
#include <stdlib.h>
#include <win.h>
#include <sys\types.h>
#include <sys\stat.h>

#define BASE_PORT 0x300
#define OR ||
#define NO_CURSOR 0x2000
#define CURSOR    0x0707

#include "intrcrd1.c"

unsigned int mode;

main()
   {
   unsigned int i, j;

   WINDOW help;
   WINDOW menu;
   WINDOW file;
   WINDOW record;
   WINDOW keyb;
   WINDOW burp;

   _segment display_ram;
   unsigned int _based(display_ram) *screen;

   char string[30], *sample_ptr, loop_flag=1, sample_flag=0, save_flag=0, ch;
   unsigned int sample_size, del, result;
   int filehandle;

   int hiccup, key;     /* hiccup is the delay value */
   unsigned int loop;
   char *play, fin;   /* pointer to data buffer    */

   unsigned int length;
   char *buf;

   /* main program code */

   /* is this correct video mode ? */

   mode=win_getvmode();
   _setactivepage(1);

   switch (mode)
	{
	case 7:
	case 2:
		display_ram = 0xb000 + (0x100 * _getactivepage());
		break;
	case 3:
		display_ram = 0xb800 + (0x100 * _getactivepage());
		break;
	default:
		printf("**      Incorrect video mode      **\n");
		printf("-- must be an 80-column text mode --\n\n");
		exit(1);
		break;
	}

   strcpy(string,"InterCard 1 ");
   screen=NULL;
   for (i=0; i<168; i++)
	for (j=0; j<12; j++)
		*screen++ = 0x3A00 + (0xFF & string[j]);

   _setvisualpage(1);
   _settextcursor ( NO_CURSOR );

   /* create windows */

   title_page();

   burp.mode=mode;      /* burp is a general window for error messages */
   burp.bback=LRED;
   burp.bfore=LWHITE;
   burp.wback=WHITE;
   burp.wfore=LRED;
   burp.tcolour=LWHITE;
   if (win_create(&burp,15,10,50,4)==0)
	exit(0);
   burp.explode=TRUE;
   burp.shadow=TRUE;

   keyb.mode=mode;
   keyb.bback=RED;
   keyb.bfore=LWHITE;
   keyb.wback=WHITE;
   keyb.wfore=LRED;
   keyb.tcolour=LWHITE;
   if (win_create(&keyb,15,10,50,5)==0)
	exit(0);
   keyb.explode=TRUE;
   keyb.shadow=TRUE;
   strcpy(keyb.title," KEYBOARD PLAYER ");

   menu.mode=mode;
   menu.bback=BLUE;
   menu.bfore=LWHITE;
   menu.wback=WHITE;
   menu.wfore=LWHITE;
   menu.tcolour=LWHITE;
   if (win_create(&menu,4,1,70,4)==0)
	exit(0);

   strcpy(menu.title,"  Sound Recorder        version 2.0  ");
   menu.shadow=TRUE;
   menu.bstyle=2;
   menu.explode=TRUE;
   win_show (&menu);
   win_string ( &menu,2,1,LWHITE,"<R>ecord  <P>layback  <K>eyboard  <E>dit  <S>ave  <L>oad  <Q>uit");


   while(loop_flag)
   {
	 switch(get_menu_selection())
	 {
	 case 'R':
	 case 'r':
		 if (sample_flag)
			{
			free(sample_ptr);
			}
		 win_show(&burp);
		 win_string(&burp,2,1,LWHITE,"No of samples (65000 max) :                  ");
		 i=0;
		 ch=0;
		 do
		  {
		  ch=getch();
		  if ((ch>='0') && (ch<='9'))
			  {
			  if (i>4) i=4;
			  win_print(&burp,30+i,1,BLUE,ch);
			  string[i]=ch;
			  i++;
			  }

		  if (ch==8)
			  {
			  i--;
			  string[i]=0;
			  win_print(&burp,30+i,1,BLUE,32);

			  if (i>6) i=0;
			  }

		  if (ch==13)
			  string[i]=0;
		  }
		 while(ch!=13);
		 win_hide(&burp);

	    sample_size=atoi(string);

		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"Delay (0 - 255) :                             ");
		  i=0;
		  ch=0;
		  do
		   {
		   ch=getch();
		   if ((ch>='0') && (ch<='9'))
			   {
			   win_print(&burp,20+i,1,BLUE,ch);
			   string[i]=ch;
			   i++;
			   }

		   if (ch==8)
			   {
			   i--;
			   if (i>4) i=0;
			   string[i]=0;
			   win_print(&burp,20+i,1,BLUE,32);
			   }

		   if (ch==13)
			   string[i]=0;
		   }
		  while(ch!=13);
		  win_hide(&burp);

	    del=atoi(string);
	    if (del>255)
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"         Error >> delay too long !           ");
		  getch();
		  win_hide(&burp);
		  break;
		  }

    /* now allocate enough memory for the sample */

	    if ( (sample_ptr=(unsigned char*) malloc((size_t)sample_size))==NULL)
		    {
		    win_show(&burp);
		    win_string(&burp,2,1,LWHITE,"         Error >> not enough memory !        ");
		    getch();
		    win_hide(&burp);
		    break;
		    }

    /* o.k. got block of memory, now get ready to take sample... */
	    win_show(&burp);
	    win_string(&burp,2,1,LWHITE,"    Press RETURN key to start recording.... ");

	    getch();

    /* o.k. now record the sample*/
	    beep();
	    win_string(&burp,2,1,LWHITE,"           << R E C O R D I N G >>          ");

	    if ((result=_GetSample ( sample_ptr, sample_size, (unsigned char)del))==-1)
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"         Error >> can't record sample !      ");
		  getch();
		  win_hide(&burp);
		  break;
		  }
	    win_string(&burp,2,1,LWHITE,"           <<  F I N I S H E D  >>          ");
	    beep();
	    pause(1000);
	    win_hide(&burp);
	    sample_flag=1;
	    save_flag=0;
	    break;

	 case 'P':
	 case 'p':
	    if(sample_flag)
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"Playback speed (0 - 255) :                   ");
		  i=0;
		  ch=0;
		  do
		   {
		   ch=getch();
		   if ((ch>='0') && (ch<='9'))
			   {
			   win_print(&burp,29+i,1,BLUE,ch);
			   string[i]=ch;
			   i++;
			   }

		   if (ch==8)
			   {
			   i--;
			   if (i>20) i=0;
			   string[i]=0;
			   win_print(&burp,29+i,1,BLUE,32);
			   }

		   if (ch==13)
			   string[i]=0;
		   }
		  while(ch!=13);
		  win_hide(&burp);

		  del=atoi(string);
		  if (del>255)
			{
			win_show(&burp);
			win_string(&burp,2,1,LWHITE,"         Error >> speed out of range !       ");
			getch();
			win_hide(&burp);
			break;
			}

   /* now play the sound through the DAC board */

		  if ( _PlaySample( sample_ptr,(unsigned int)sample_size,(char)del ) == -1 )
			{
			win_show(&burp);
			win_string(&burp,2,1,LWHITE,"         Error >> can't play sample !        ");
			getch();
			win_hide(&burp);
			break;
			}
		  }
	    else
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"        Error >> There's no sample to play !    ");
		  getch();
		  win_hide(&burp);
		  }
	    break;

	 case 'K':
	 case 'k':
   /* now play the sound through the DAC board */

	    if(sample_flag)
		  {
		  win_show(&keyb);
		  win_string(&keyb,2,0,LWHITE,"Keyboard      2 3    5 6 7     ");
		  win_string(&keyb,2,1,LWHITE," layout       ˼ ˼    ˼ ˼ ˼     ");
		  win_string(&keyb,2,2,LWHITE,"--------     q  w  e  r  t  y  u  i ");
		  win_string(&keyb,2,3,LWHITE,"x - quit    ");
		  do
			  {
			  key=getch();
			  switch (key)
				{
				case 'q': hiccup=49;  break;
				case '2': hiccup=44;  break;
				case 'w': hiccup=40;  break;
				case '3': hiccup=36;  break;
				case 'e': hiccup=33;  break;
				case 'r': hiccup=30;  break;
				case '5': hiccup=28;  break;
				case 't': hiccup=25;  break;
				case '6': hiccup=23;  break;
				case 'y': hiccup=20;  break;
				case '7': hiccup=17;  break;
				case 'u': hiccup=14;  break;
				case 'i': hiccup=12;  break;
				}
			  if ((key=='q') OR (key=='2') OR (key=='w') OR (key=='3') OR
			   (key=='e') OR (key=='r') OR (key=='5') OR (key=='t') OR
			   (key=='6') OR (key=='y') OR (key=='7') OR (key=='u') OR
			   (key=='i') OR (key=='x'))
				  {
				  play=sample_ptr;
				  if (key!='x')
					  {
					  fin=1;
					  loop=0;
					  do
						{
						outp(BASE_PORT,(int)*play + 0);
						pause (hiccup);
						play++;
						loop++;
						if (!(loop%200))
						   {
						   fin=!kbhit();
						   }
						}
					  while((loop<sample_size) && fin);
					  }
				  }
			  }
		  while (key!='x');
		  win_hide(&keyb);
		}

	    break;

	 case 'E':
	 case 'e':
	    if (sample_flag)
		  {
		  /* now offer the edit window */

		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"  <E>cho  <R>everse  <V>olume                ");
		  switch(getch())
			{
			case 'E':
			case 'e':
				{   /* let's Echo..o..o.o.o. */
				int echo_time;
				win_string(&burp,2,1,LWHITE,"  Enter echo time (1 to 10):        ");
				i=0;
				ch=0;
				do
				   {
				   ch=getch();
				   if ((ch>=48) && (ch<=57))
					 {
					 win_print(&burp,31+i,1,BLUE,ch);
					 string[i]=ch;
					 i++;
					 }
				   if (ch==8)
					 {
					 i--;
					 if (i>2) i=0;
					 string[i]=0;
					 win_print(&burp,31+i,1,BLUE,32);
					 }
				   if (ch==13)
					 string[i]=0;
				   }
				while(ch!=13);

				/* now process echo */

				echo_time=atoi(string);
				echo_time=100*echo_time;
				if (echo_time < sample_size)
					{
					char *echo_ptr;
					echo_ptr=sample_ptr;
					echo_ptr=echo_ptr+sample_size;
					for (i=0;i<(sample_size-echo_time);i++)
						{
						if ( *(echo_ptr-echo_time) >= 128)
							{
							*echo_ptr= *echo_ptr + (( *(echo_ptr-echo_time) - 128 ) >> 6);
							}
						else
							{
							*echo_ptr= *echo_ptr - (( *(echo_ptr-echo_time) ) >> 6);
							}
						echo_ptr--;
						}
					}
				/* all done so finish */
				break;
				}

			case 'R':
			case 'r':
				{

				break;
				}

			case 'V':
			case 'v':
				{

				break;
				}
			}
		  win_hide(&burp);
		  }
	    else
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"         Error >> No sample to edit !       ");
		  getch();
		  win_hide(&burp);
		  }
	    break;

	 case 'S':
	 case 's':
	    if (sample_flag)
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"Enter name of file :                         ");
		  i=0;
		  ch=0;
		  do
		   {
		   ch=getch();
		   if (((ch>=48) && (ch<=57)) || ((ch>=65) && (ch<=90)) || ((ch>=97) && (ch<=122))
					  || (ch==46) || (ch==45)  || (ch==95) || (ch==58) || (ch==92))
			   {
			   win_print(&burp,23+i,1,BLUE,ch);
			   string[i]=ch;
			   i++;
			   }

		   if (ch==8)
			   {
			   i--;
			   if (i>20) i=0;
			   string[i]=0;
			   win_print(&burp,23+i,1,BLUE,32);
			   }

		   if (ch==13)
			   string[i]=0;
		   }
		  while(ch!=13);
		  win_hide(&burp);

		  if( ( filehandle=open( string, O_BINARY | O_CREAT | O_RDWR, S_IREAD | S_IWRITE) ) == -1L)
			  {
			  win_show(&burp);
			  win_string(&burp,2,1,LWHITE,"         Error >> cannot create file !       ");
			  getch();
			  win_hide(&burp);
			  break;
			  }

		  if( write( filehandle,sample_ptr,(unsigned)sample_size ) == -1 )
			  {
			  win_show(&burp);
			  win_string(&burp,2,1,LWHITE,"         Error >> cannot write to file !     ");
			  getch();
			  win_hide(&burp);
			  break;
			  }

		  close(filehandle);
		  save_flag=1;
		  }
	    else
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"         Error >> No sample to save !       ");
		  getch();
		  win_hide(&burp);
		  }
	    break;

	 case 'L':
	 case 'l':
	    if (sample_flag)
		  {
		  char answer;
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"    Sample not saved.      Continue (y/n) ?  ");
		  answer=getch();
		  if (answer=='n' || answer=='N')  /* No ! */
			  {
			  win_hide(&burp);
			  break;
			  }
		  win_hide(&burp);
		  }
	    free(sample_ptr);
	    win_show(&burp);
	    win_string(&burp,2,1,LWHITE,"Enter name of file :                         ");
	    i=0;
	    ch=0;
	    do
		{
		ch=getch();
		if(((ch>='0') && (ch<='9')) || ((ch>='A') && (ch<='Z')) || ((ch>='a') && (ch<='z'))
				    || (ch=='.') || (ch=='-')  || (ch=='_') || (ch==':') || (ch=='\\'))
			{
			win_print(&burp,23+i,1,BLUE,ch);
			string[i]=ch;
			i++;
			}

		if (ch==8)
			{
			i--;
			if (i>20) i=0;
			string[i]=0;
			win_print(&burp,23+i,1,BLUE,32);
			}

		if (ch==13)
			string[i]=0;
		}
	    while(ch!=13);
	    win_hide(&burp);

   /* can we open the named sound file ?  */

	    if( ( filehandle=open( string,O_BINARY | O_RDONLY) ) == -1L)
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"         Error >> cannot open file.          ");
		  getch();
		  win_hide(&burp);
		  break;
		  }

   /* will this file fit inside 64k ? */

	    if ((length=filelength(filehandle))>65535)
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"        Error >> file is too big.            ");
		  getch();
		  win_hide(&burp);
		  break;
		  }

   /* yes it is, but is there enough memory available to hold it ? */

	    if( (buf=(char *)malloc((size_t)length))==NULL)
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"  Error >> not enough memory to store file   ");
		  getch();
		  win_hide(&burp);
		  break;
		  }

   /* ok, so read in blocks of data if possible */

	    if( read( filehandle,buf,(unsigned)length ) == -1 )
		  {
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"         Error >> cannot read file.          ");
		  getch();
		  win_hide(&burp);
		  break;
		  }
	    sample_size=length;
	    sample_ptr=buf;
	    close(filehandle);
	    sample_flag=1;
	    save_flag=1;
	    break;

	 case 'Q':
	 case 'q':
	    if(sample_flag && !save_flag)
		  {
		  char answer;
		  win_show(&burp);
		  win_string(&burp,2,1,LWHITE,"     Sample not saved.  Continue (y/n) ?     ");
		  answer=getch();
		  if (answer=='n' || answer=='N')  /* No ! */
			{
			win_hide(&burp);
			break;
			}
		  win_hide(&burp);
		  }
	    loop_flag=0;
	    break;

	 default:           /* have not pressed a valid menu option */
	    beep();
	    break;
	 }
	}
   if (sample_flag)
	 free( sample_ptr );

   win_hide (&menu);
   win_kill (&menu);

   _setactivepage(0);
   _setvisualpage(0);
   _settextcursor ( CURSOR );

   }

/*********************************************************************/
/*              FUNCTIONS                                            */
/*********************************************************************/


title_page()
	{
	WINDOW my_win;

	my_win.mode=mode;
	my_win.bback=GREEN;
	my_win.bfore=LWHITE;
	my_win.wback=WHITE;
	my_win.wfore=LWHITE;

	if (win_create( &my_win,1,1,75,20)==0)
		{
		return 0;
		}

	my_win.tcolour=LGREEN;
	my_win.bstyle=2;
	strcpy(my_win.title,"Intercard 1");
	my_win.shadow=TRUE;

	win_show (&my_win);

	win_string ( &my_win,15,2,LBLUE,"The Intercard 1 Universal Interface Card");
	win_string ( &my_win,30,4,LBLUE,"For The PC");
	win_string ( &my_win,27,8,LWHITE,"    ");
	win_string ( &my_win,27,9,LWHITE,"             ");
	win_string ( &my_win,27,10,LWHITE,"           ");
	win_string ( &my_win,27,11,LWHITE,"             ");
	win_string ( &my_win,27,12,LWHITE,"        ");
	win_string ( &my_win,25,17,LMAGENTA,"Press a key to continue");

	getch();
	win_hide (&my_win);
	win_kill (&my_win);
	}


get_menu_selection()
   {
   char answer;

   answer = getch();
   return(answer);
   }

beep()
   {
   printf("\a");
   }

pause ( delay )
int delay;
   {
   int loop;
   for (loop=0;loop<delay;loop++)
	{
	_asm nop
	}
   }

